/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the HttpZohoDestinationAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &HttpZohoDestinationAllOf{}

// HttpZohoDestinationAllOf struct for HttpZohoDestinationAllOf
type HttpZohoDestinationAllOf struct {
	OAuthId *int32  `json:"o_auth_id,omitempty"`
	Module  *string `json:"module,omitempty"`
}

// NewHttpZohoDestinationAllOf instantiates a new HttpZohoDestinationAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewHttpZohoDestinationAllOf() *HttpZohoDestinationAllOf {
	this := HttpZohoDestinationAllOf{}
	return &this
}

// NewHttpZohoDestinationAllOfWithDefaults instantiates a new HttpZohoDestinationAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewHttpZohoDestinationAllOfWithDefaults() *HttpZohoDestinationAllOf {
	this := HttpZohoDestinationAllOf{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *HttpZohoDestinationAllOf) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *HttpZohoDestinationAllOf) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *HttpZohoDestinationAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *HttpZohoDestinationAllOf) SetOAuthId(v int32) {
	o.OAuthId = &v
}

// GetModule returns the Module field value if set, zero value otherwise.
func (o *HttpZohoDestinationAllOf) GetModule() string {
	if o == nil || IsNil(o.Module) {
		var ret string
		return ret
	}
	return *o.Module
}

// GetModuleOk returns a tuple with the Module field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *HttpZohoDestinationAllOf) GetModuleOk() (*string, bool) {
	if o == nil || IsNil(o.Module) {
		return nil, false
	}
	return o.Module, true
}

// HasModule returns a boolean if a field has been set.
func (o *HttpZohoDestinationAllOf) HasModule() bool {
	if o != nil && !IsNil(o.Module) {
		return true
	}

	return false
}

// SetModule gets a reference to the given string and assigns it to the Module field.
func (o *HttpZohoDestinationAllOf) SetModule(v string) {
	o.Module = &v
}

func (o HttpZohoDestinationAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o HttpZohoDestinationAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["o_auth_id"] = o.OAuthId
	}
	if !IsNil(o.Module) {
		toSerialize["module"] = o.Module
	}
	return toSerialize, nil
}

type NullableHttpZohoDestinationAllOf struct {
	value *HttpZohoDestinationAllOf
	isSet bool
}

func (v NullableHttpZohoDestinationAllOf) Get() *HttpZohoDestinationAllOf {
	return v.value
}

func (v *NullableHttpZohoDestinationAllOf) Set(val *HttpZohoDestinationAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableHttpZohoDestinationAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableHttpZohoDestinationAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableHttpZohoDestinationAllOf(val *HttpZohoDestinationAllOf) *NullableHttpZohoDestinationAllOf {
	return &NullableHttpZohoDestinationAllOf{value: val, isSet: true}
}

func (v NullableHttpZohoDestinationAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableHttpZohoDestinationAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
